var base_domain = 'http://toh-speed.local/';
var base_domain = 'https://gospeedcheck.com/';
var lang = 'en';
var setting_obj = {
    'unit-time-layout': '12h',
    'unit-date-layout': 'mm/dd/yyyy',
    'unit-distance-layout': 'kilometers',
    'unit-speed-layout': 'Mbps',
    'unit-server-layout': 0,
};
var list_server = []
var result_obj = []
var list_server_nearest = [];
var numberRefresh = 1;
var speedRefresh = 500;

var pingMilisecond = '';
var speedDownload = '';
var speedUpload = '';
var last_host_tested = '';

var lat_current_user = '';
var lon_current_user = '';
var country_current_server = '';
var lat_server = '';
var lon_server = '';
var host_name = '';
var ip_user = '';
var sponsor = '';
var city = '';
var host_id = '';
var pingTime = 0;
var upload_average = 0;
var max_upload_timeout = 30;
var upload_called_done = 0;
var download_average = 0;
var download_last_data = 0;
var max_download_timeout = 30;
var download_called_done = 0;
var upload_file_in_bit = 0;
var upload_file_data = false;
var status_background_running = false;
var all_result_objs = [];
var last_result_obj = false;
var last_clock_percent = 0;
var last_running_time = false;

function createUserID(length){
    var result           = '';
    var characters       = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';
    var charactersLength = characters.length;
    for ( var i = 0; i < length; i++ ){
        result += characters.charAt(Math.floor(Math.random() * charactersLength));
    }
    return result;
}
function checkCookieOfUserID(){
    var user_id = Cookies.get("user_id");
    if(!user_id){
        Cookies.set('user_id', createUserID(25));
    }
}
function deg2rad(deg){
    return deg * (Math.PI/180)
}
function getDistanceFromLatLonInKm(lat1,lon1,lat2,lon2){
    var R = 6371; // Radius of the earth in km
    var dLat = deg2rad(lat2-lat1);  // deg2rad below
    var dLon = deg2rad(lon2-lon1); 
    var a = 
        Math.sin(dLat/2) * Math.sin(dLat/2) +
        Math.cos(deg2rad(lat1)) * Math.cos(deg2rad(lat2)) * 
        Math.sin(dLon/2) * Math.sin(dLon/2)
        ; 
    var c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1-a)); 
    var d = R * c; // Distance in km
    return d;
}
function generateRandomNumber(min, max){
    highlightedNumber = Math.random() * (max - min) + min;
    return highlightedNumber.toFixed(2);
};
function getQueryVariable(variable){
    var query = window.location.search.substring(1);
    var vars = query.split("&");
    for (var i=0;i<vars.length;i++){
        var pair = vars[i].split("=");
        if(pair[0] == variable && variable !== ''){
            variable = pair[1];
            return variable;
        }
    }
    return false;
}

//Download function
function checkDownloadSpeed(url, numberRefresh, speedRefresh, callback){
    download_average = 0;
    download_called_done = 0;
    download_last_data = 0;
    checkDownloadInterval(url, numberRefresh, speedRefresh, 0, callback);
};
function checkDownloadInterval(url, total_interval, timeout, counter, callback){
    if(counter < total_interval){
        callDownloadAjax(url, function(download_type, cur_speed, ping_time){
            if(download_type == 'end'){
                download_called_done++;
                if(download_called_done >= total_interval){
                    callback('end', cur_speed, ping_time); 
                }else{
                    callback('percent', cur_speed, ping_time); 
                }
            }else{
                callback('percent', cur_speed, ping_time);
            }
        });
        setTimeout(function(){
            checkDownloadInterval(url, total_interval, timeout, counter + 1, callback);
        }, timeout);
    }
}
function callDownloadAjax(url, callback){
    var startTime = new Date();
    var initTime = startTime;
    var download_speed_per_kbit = 0;
    function updateProgress(evt){
        if(evt.lengthComputable){
            var endTime = new Date();
            var percentComplete = (evt.loaded / evt.total) * 100;  
            if(percentComplete >= 100){
                var download_second = ((endTime.getTime() - startTime.getTime()) / 1000);
                var total_data = convertByteToBit(evt.loaded - download_last_data);
                var download_speed_per_bit = total_data / download_second;
                download_speed_per_kbit = convertSpeedBpsToKBps(download_speed_per_bit);
                callback('end', download_speed_per_kbit, pingTime);
            }else{
                if(download_last_data == 0){
                    startTime = new Date();
                    download_last_data = evt.loaded;
                }else{
                    var download_second = ((endTime.getTime() - startTime.getTime()) / 1000);
                    var total_data = convertByteToBit(evt.loaded - download_last_data);
                    var download_speed_per_bit = total_data / download_second;
                    download_speed_per_kbit = convertSpeedBpsToKBps(download_speed_per_bit);
                    // console.log('Download:' + download_speed_per_kbit + '|' + percentComplete + '|' + download_second);
                    callback('percent', download_speed_per_kbit, pingTime);
                }
            }
        }
    }
    var xhr = new XMLHttpRequest();
    xhr.open('GET', url, true);
    xhr.timeout = max_download_timeout*1000;
    xhr.onprogress = updateProgress;
    xhr.onreadystatechange = function(){
        if(xhr.readyState == 2){
            startTime = new Date();
            pingTime = Math.round((startTime.getTime() - initTime.getTime()));
        }
        if(xhr.readyState == 4 && xhr.status != 200){}
    };
    xhr.onerror = function (er){ 
        callback('end', 0, pingTime);
    }; 
    xhr.ontimeout = function (e){
        callback('end', download_speed_per_kbit, pingTime);
    };
    xhr.send();
}

//Upload function
function checkUploadSpeed(url, numberRefresh, speedRefresh, callback){
    upload_average = 0;
    upload_called_done = 0;
    checkUploadInterval(url, upload_file_data, upload_file_in_bit, numberRefresh, speedRefresh, 0, callback);
};
function checkUploadInterval(url, data, sizeInBit, total_interval, timeout, counter, callback){
    if(counter < total_interval){
        callUploadAjax(url, data, sizeInBit, function(upload_type, cur_speed){
            if(upload_type == 'end'){
                upload_called_done++;
                if(upload_called_done >= total_interval){
                    callback('end', cur_speed); 
                }else{
                    callback('percent', cur_speed); 
                }
            }else{
                callback('percent', cur_speed);
            }
        });
        setTimeout(function(){
            checkUploadInterval(url, data, sizeInBit, total_interval, timeout, counter + 1, callback);
        }, timeout);
    }
}
function callUploadAjax(url, data, sizeInBit, callback){
    var startTime = new Date();
    var upload_speed_per_kbit = 0;
    function updateProgress(evt){
        if(evt.lengthComputable){                   
            var endTime = new Date();
            var percentComplete = (evt.loaded / evt.total) * 100;
            if(percentComplete >= 100){
                var upload_second = ((endTime.getTime() - startTime.getTime()) / 1000);
                var total_data = convertByteToBit(evt.loaded);
                var upload_speed_per_bit = total_data / upload_second;
                upload_speed_per_kbit = convertSpeedBpsToKBps(upload_speed_per_bit);
                callback('end', upload_speed_per_kbit);
            }else{
                var upload_second = ((endTime.getTime() - startTime.getTime()) / 1000);
                var total_data = evt.loaded;
                var upload_speed_per_bit = total_data * 8 / upload_second;
                if(upload_second > 0){
                    upload_speed_per_kbit = convertSpeedBpsToKBps(upload_speed_per_bit);
                    // console.log('Upload:' + upload_speed_per_kbit + '|' + percentComplete + '|' + upload_second);
                    callback('percent', upload_speed_per_kbit);
                }
            }
        }
    }
    var xhr = new XMLHttpRequest();
    xhr.timeout = max_upload_timeout*1000;
    xhr.upload.addEventListener("progress", updateProgress, false);
    xhr.onreadystatechange = function(){ 
        if(xhr.readyState == 4 && xhr.status != 200){}
    };
    xhr.onerror = function (er){ 
        callback('end', 0);
    }; 
    xhr.ontimeout = function (e){
        callback('end', upload_speed_per_kbit);
    };
    xhr.open('POST', url, true);
    xhr.send(data);
}
function getRandomString(callback){
    upload_file_data = JSON.stringify(new Array(25 * 10 * 20000));
    upload_file_in_bit = upload_file_data.length * 8;
    callback();
};

//Upload download utils
function saveResultToServer(speedKbpsDownload, speedKbpsUpload, pingTime, last_time, callback){
    $.ajaxSetup({headers:{'X-CSRF-TOKEN': createUserID(25) }});
    var data = {
        ping: pingTime, 
        download: Math.round(speedKbpsDownload),
        upload: Math.round(speedKbpsUpload), 
        city : city,
        sponsor : sponsor,
        host_name: host_name,
        ip : ip_user,
        distance: getDistanceFromLatLonInKm(lat_current_user, lon_current_user, lat_server, lon_server).toFixed(1),
        host_id: host_id,
        created_at : Math.round((new Date().getTime())/1000),
    };
    $.ajax({
        method : "GET",
        url: base_domain + "save-gauge-logs-extension",
        data: data,
        success: function(response){
            response = response ? JSON.parse(response) : {};
            callback((response && response.hasOwnProperty('id')) ? response.id : false, last_time);
        },
        error: function(data){
            callback(false, last_time);
        }
    });
}

function convertMBtoBit(number){
    return number*1000*1000*8;
}
function convertMBtoByte(number){
    return number*1000*1000;
}
function convertSpeedBpsToKBps(number){
    return number / 1000;
}
function convertByteToBit(number){
    return number*8;
}
function convertKBpsToMBps(number){
    return number / 1000;
}
function convertMBpsToKBps(number){
    return number * 1000;
}

function formatSpeedUnit(number){
    if(number >= 10){
        return number.toFixed(0);
    }else{
        return number.toFixed(2);
    }
}
function formatSpeedUnitMBit(number){
    return number.toFixed(3);
}
function getTextWidth(txt, font){
    this.element = document.createElement('canvas');
    this.context = this.element.getContext("2d");
    this.context.font = font;
    return this.context.measureText(txt).width;
}

function callTestUploadDownload(list_server_nearest, flag){
    lat_server = list_server_nearest[flag].lat;
    lon_server = list_server_nearest[flag].lon;
    city = list_server_nearest[flag].name;
    sponsor = list_server_nearest[flag].sponsor;
    host_id = list_server_nearest[flag].id;
    last_host_tested = list_server_nearest[flag].sponsor;

    var s = new Speedtest();
    s.addTestPoints(list_server_nearest);
    s.setSelectedServer(list_server_nearest[flag]);
    s.start();

    return;






    pingMilisecond = '';
    speedDownload = '';
    speedUpload = '';
    last_host_tested = '';
    last_running_time = new Date().getTime();
    getRandomString(function(){
        lat_server = list_server_nearest[flag].lat;
        lon_server = list_server_nearest[flag].lon;
        city = list_server_nearest[flag].name;
        sponsor = list_server_nearest[flag].sponsor;
        host_id = list_server_nearest[flag].id;
        last_host_tested = list_server_nearest[flag].name + ' - ' + list_server_nearest[flag].sponsor;


        
        var avoidCache = "?avoidcache=" + (new Date()).getTime();
        var download_url = 'http://' + (list_server_nearest[flag].host) + '/speedtest/random3000x3000.jpg' + avoidCache;
        var upload_url = 'http://' + (list_server_nearest[flag].host) + '/speedtest/upload.php';
        
        all_result_objs.push({'type': 'reset', 'ping': pingMilisecond, 'download': speedDownload, 'upload': speedUpload});
        checkDownloadSpeed(download_url, numberRefresh, speedRefresh, function(download_type, download_average, ping_time){
            if(download_average > 0){
                pingMilisecond = ping_time;
                speedDownload = download_average;
                all_result_objs.push({'type': 'download', 'ping': pingMilisecond, 'download': speedDownload, 'upload': speedUpload});
                if(download_type == 'end'){
                    all_result_objs.push({'type': 'reset', 'ping': pingMilisecond, 'download': speedDownload, 'upload': speedUpload});
                    checkUploadSpeed(upload_url, numberRefresh, speedRefresh, function(upload_type, upload_average){
                        if(upload_average > 0){
                            speedUpload = upload_average;
                            all_result_objs.push({'type': 'upload', 'ping': pingMilisecond, 'download': speedDownload, 'upload': speedUpload});
                            if(upload_type == 'end'){
                                all_result_objs.push({'type': 'end_upload', 'ping': pingMilisecond, 'download': speedDownload, 'upload': speedUpload});
                                status_background_running = false;
                                saveResultToServer(download_average, upload_average, ping_time, last_running_time, function(result_id, last_time){
                                    if(last_time == last_running_time){
                                        if(result_id !== false){
                                            localStorage.setItem("result_id", result_id);
                                            localStorage.setItem("ping_time", pingTime);
                                            localStorage.setItem("download_average", convertKBpsToMBps(download_average).toFixed(2));
                                            localStorage.setItem("upload_average", convertKBpsToMBps(upload_average).toFixed(2));
                                            all_result_objs.push({'type': 'done', 'ping': pingMilisecond, 'download': speedDownload, 'upload': speedUpload, 'result_id': result_id});
                                        }else{
                                            all_result_objs.push({'type': 'done', 'ping': pingMilisecond, 'download': speedDownload, 'upload': speedUpload, 'result_id': false});
                                        }
                                    }
                                });
                            }
                        }else if(upload_type == 'end'){
                            all_result_objs.push({'type': 'error', 'ping': pingMilisecond, 'download': speedDownload, 'upload': speedUpload});
                            status_background_running = false;
                        }
                    });
                }
            }else if(download_type == 'end'){
                all_result_objs.push({'type': 'error', 'ping': pingMilisecond, 'download': speedDownload, 'upload': speedUpload});
                status_background_running = false;
            }
        });
    });
}

function getAddressByIp(callback){
    $.ajax({
        type: 'GET',
        url: "https://ipinfo.io/json",
        cache: false,
        success: function(response){
            var loc = response.loc ? response.loc : '';
            if(loc){
                var loc_arrs = loc.toString().split(',');
                 callback(loc_arrs[0], loc_arrs[1], response.country ? response.country : '', response.org, response.ip);
            }else{
                callback(false, false, response.country ? response.country : '', response.org, response.ip);
            }
        }, error: function (xhr, ajaxOptions, thrownError) {
            callback(false, false, '', '', '');
        }
    });
}
function findNearestServers(type, callback){
    if(type == 'start' && lat_current_user === ''){
        getAddressByIp(function(lat, lon, country, org, ip){
            if(lat !== false){
                lat_current_user = lat;
                lon_current_user = lon;
                country_current_server = country;
                host_name = org;
                ip_user = ip;
            }
            findNearestServers('end', callback);
        });
    }else{
        for(let i = 0; i < list_server.length; ++i){
            var cur_distance = getDistanceFromLatLonInKm(lat_current_user, lon_current_user, list_server[i].lat, list_server[i].lon);
            list_server[i].distance = cur_distance;
        }
        list_server.sort(function(a, b) {
            return a.distance - b.distance;
        });
        
        var nearest_servers = [];
        var other_servers = [];
        for(let i = 0; i < list_server.length; ++i){
            if(list_server[i].cc == country_current_server){
                nearest_servers.push(list_server[i]);
            }else{
                other_servers.push(list_server[i]);
            }
        }
        list_server_nearest = nearest_servers.concat(other_servers);
        callback();
    }
}
function getListServer(callback){
    if(list_server.length > 0){
        callback(true);
    }else{
        $.ajaxSetup({headers:{'X-CSRF-TOKEN': createUserID(25) }});
        $.ajax({
            method : "GET",
            url: base_domain + "api/getListServerExtension",
            data: { },
            success: function(response){
                list_server = response.list_server
                callback(true);
            },
            error: function(data){
                callback(false);
            }
        });
    }
}
function sendMessageToPopup(badge_text, obj){
    try{
        if(badge_text === 'done'){
            if(arr_port.length > 0){
                chrome.browserAction.setBadgeText({"text": ''});
            }else{
                chrome.browserAction.setBadgeText({"text": ' '});
            }
        }else if(badge_text !== 'none'){
            chrome.browserAction.setBadgeText({"text": badge_text});
        }
        for (let i = 0; i < arr_port.length; ++i){
            arr_port[i].postMessage(JSON.stringify(obj));
        }
    }catch(err){}
}
function resetLocalStorage(){
    localStorage.removeItem("result_id");
    localStorage.removeItem("ping_time");
    localStorage.removeItem("download_average");
    localStorage.removeItem("upload_average");
}
function setClockPercent(cur_percent){
    cur_percent = cur_percent > 100 ? 100 : cur_percent;
    last_clock_percent = cur_percent;
}
function setClockByRange(cur_obj, from, to, callback){
    if(from == to){
        callback();
    }else{
        if(from < to){
            from += 1;
            if(from > to){
                from = to;
            }
            setClockPercent(from);
            cur_obj.percent = from;
            sendMessageToPopup(cur_obj.badge, cur_obj);
            setTimeout(function(){
                setClockByRange(cur_obj, from, to, callback);
            }, 3);
        }else{
            from -= 1;
            if(from < to){
                from = to;
            }
            setClockPercent(from);
            cur_obj.percent = from;
            sendMessageToPopup(cur_obj.badge, cur_obj);
            setTimeout(function(){
                setClockByRange(cur_obj, from, to, callback);
            }, 3);
        }
    }
}
        
function showTestResultObjs(counter){
    var wait_timeout = 30;
    var reset_timeout = 300;
    var max_wait_step = 100;
    if(all_result_objs[counter]){
        var cur_obj = jQuery.extend({}, all_result_objs[counter]);
        cur_obj.download = cur_obj.download !== '' ? convertKBpsToMBps(cur_obj.download).toFixed(2) : '';
        cur_obj.upload = cur_obj.upload !== '' ? convertKBpsToMBps(cur_obj.upload).toFixed(2) : '';
        if(cur_obj.type == 'start'){
            cur_obj.badge = 'none';
        }else if(cur_obj.type == 'reset'){
            cur_obj.badge = '0';
        }else if(cur_obj.type == 'download'){
            cur_obj.badge = cur_obj.download;
        }else if(cur_obj.type == 'upload'){
            cur_obj.badge = cur_obj.upload; 
        }else{
            cur_obj.badge = 'done';     
        }
        last_result_obj = cur_obj;
        
        if(cur_obj.type == 'reset'){
            setClockByRange(cur_obj, last_clock_percent, 0, function(){
                setTimeout(function(){
                    showTestResultObjs(counter + 1);
                }, reset_timeout);
            });
        }else if(cur_obj.type == 'done'){
            setClockPercent(0);
            sendMessageToPopup(cur_obj.badge, cur_obj);
        }else if(cur_obj.type == 'end_upload'){
            var new_cur_obj = jQuery.extend({}, cur_obj);
            new_cur_obj.type = 'progress_end_upload';
            setClockByRange(new_cur_obj, last_clock_percent, 0, function(){
                sendMessageToPopup(cur_obj.badge, cur_obj);
                setTimeout(function(){
                    showTestResultObjs(counter + 1);
                }, reset_timeout);
            });
        }else if(cur_obj.type == 'download' && last_clock_percent == 0){
            setClockByRange(cur_obj, 0, cur_obj.download, function(){
                setTimeout(function(){
                    showTestResultObjs(counter + 1);
                }, wait_timeout);
            });
        }else if(cur_obj.type == 'upload' && last_clock_percent == 0){
            setClockByRange(cur_obj, 0, cur_obj.upload, function(){
                setTimeout(function(){
                    showTestResultObjs(counter + 1);
                }, wait_timeout);
            });
        }else{
            if(cur_obj.type == 'start'){
                setClockPercent(0);
            }else{
                if(cur_obj.type == 'download'){
                    setClockPercent(cur_obj.download);
                }else{
                    setClockPercent(cur_obj.upload);
                }
            }
            if(cur_obj.type == 'download'){
                var end_download_step = false;
                for(var i = counter + 1; i <  all_result_objs.length; i++){
                    if(all_result_objs[i].type == 'reset'){
                        end_download_step = i;
                    }
                }
                if(end_download_step !== false && end_download_step - max_wait_step > counter){
                    counter = end_download_step - max_wait_step;
                }
            }else if(cur_obj.type == 'upload'){
                if(all_result_objs.length - max_wait_step > counter){
                    counter = all_result_objs.length - max_wait_step;
                }
            }
            sendMessageToPopup(cur_obj.badge, cur_obj);
            setTimeout(function(){
                showTestResultObjs(counter + 1);
            }, wait_timeout);
        }
    }else if(counter >= all_result_objs.length - 1){
        setTimeout(function(){
            showTestResultObjs(counter);
        }, 100);
    }
}
function runSpeedTeestEvent(){
    showTestResultObjs(0);
    all_result_objs = [];
    last_result_obj = false;
    all_result_objs.push({'type': 'start', 'ping': '', 'download': '', 'upload': ''});
    getListServer(function(success){
        if(success){
            findNearestServers('start', function(){
                callTestUploadDownload(list_server_nearest, 0);
            });
        }else{
            all_result_objs.push({'type': 'error', 'ping': pingMilisecond, 'download': speedDownload, 'upload': speedUpload});
            status_background_running = false;
        }
    });
}

var arr_port = [];
$(document).ready(function(){
    if (navigator.onLine) {
        
    } else {
        alert("No internet connection.")
    }
    resetLocalStorage();
    getListServer(function(){
        findNearestServers('start', function(){});
    });
    chrome.runtime.onConnect.addListener(function(port){
        // console.log("running")
        arr_port.push(port)
        if(status_background_running !== false){
            try{
                var send_obj = last_result_obj !== false ? last_result_obj : {'type': 'loading'};
                port.postMessage(JSON.stringify(send_obj));
            }catch(err){}
        }
        port.onMessage.addListener(function(msg){
            if(msg == 'alo' && status_background_running === false){
                status_background_running = true;
                runSpeedTeestEvent();
            }
            if(msg == 'done'){
                status_background_running = false;
            }
        });
        port.onDisconnect.addListener(function(obj){
            var index = arr_port.indexOf(obj);
            arr_port.splice(index, 1);
        });
    });
});